#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <EEPROM.h>

String html1 = "<!DOCTYPE html>\r\n<html>\r\n<head>\r\n<meta content=\"text/html; charset=ISO-8859-1\" http-equiv=\"content-type\">\r\n<title>WebSchalter</title>\r\n<form action=\"";
// String((val)?"/1.html":"/0.html")
String html2 = "\">\r\n<input value=\"ON/OFF\" style=\"";
String html3 = " width:5em;height:3em; font-size: 16px;\" type=\"submit\"></form>\r\n</head>\r\n<body>\r\n</body>\r\n</html>";

const char htmlFrame[] = "<!DOCTYPE html><html><head><meta charset=\"utf-8\"><title>IP Steckdose</title></head><body><h1>IP Steckdose</h1><script type=\"text/javascript\">setInterval(refreshIframe2, 3000);function refreshIframe2() { var frame = document.getElementById(\"Frame2\");frame.src = frame.src;}</script><iframe id=\"Frame2\" src=\"/\" name=\"IP Relais\" height=\"300\" width=\"300\" frameBorder=\"0\"></iframe></body></html>";



ESP8266WebServer server(80);// Serverport  hier einstellen
int val = 1; //Schaltzuschtand 1 ist Aus, 0 ist Ein
int i;      //Variable fuer Adresse in EEPROM

void Ereignis_SchalteON()    // Wird ausgefuehrt wenn "http://<ip address>/schalt" aufgerufen wurde
{
  val = 0;                   // Relais Aus
  digitalWrite(0, val);      // GPIO0
  server.send(200, "text/html", html1 + String((val) ? "/1.html" : "/0.html") + html2 + String((val) ? "BACKGROUND-COLOR: DarkGray;" : "BACKGROUND-COLOR: Chartreuse;") + html3 );
}

void Ereignis_SchalteOFF()    // Wird ausgefuehrt wenn "http://<ip address>/schalt" aufgerufen wurde
{
  val = 1;                     // Relais Ein
  digitalWrite(0, val);        // GPIO0
  server.send(200, "text/html", html1 + String((val) ? "/1.html" : "/0.html") + html2 + String((val) ? "BACKGROUND-COLOR: DarkGray;" : "BACKGROUND-COLOR: Chartreuse;") + html3 );
}

void Ereignis_Index()    // Wird ausgeuehrt wenn "http://<ip address>/" aufgerufen wurde
{
  server.send(200, "text/html", html1 + String((val) ? "/1.html" : "/0.html") + html2 + String((val) ? "BACKGROUND-COLOR: DarkGray;" : "BACKGROUND-COLOR: Chartreuse;") + html3 );
}

void Ereignis_Frame()    // Wird ausgefuehrt wenn "http://<ip address>/frame" aufgerufen wurde
{
  server.send(200, "text/html", htmlFrame );
}

void setup()            // Wird 1 Mal beim Start ausgefuehrt
{
  char ssid[32] = "1234\0";         //Variable fuer Wlan Name
  char passphrase[64] = "567890\0"; //Variable fuer Passwort

  digitalWrite(0, 1);             //  warscheinlich ueberfluessig
  pinMode(0, OUTPUT);             // GPIO0 als Ausgang konfigurieren
  digitalWrite(0, 1);             // Anfangszustand 1 (Relais ausgeschaltet)
  pinMode(2, INPUT_PULLUP);       // GPIO2 als Eingang mit Pullup konfigurieren

  Serial.begin(115200);             // Serielle schnittstelle initialisieren
  Serial.println("\r\n") ;          // Lehere Zeile ausgeben

  EEPROM.begin(64);                 // EEPROM initialisieren mit 64 Byts
sprungmarke:                      // Hier landen Wer wenn EEPROM leer

  // Eeeprom einlesen
  for (i = 0; i < 32; i++) ssid[i] = EEPROM.read(i);
  for (i = 32; i < 64; i++) passphrase[i - 32] = EEPROM.read(i);

  // Wenn EEPROM leer
  if (ssid[0] == 255)
  {
    Serial.println("SSID nicht konfiguriert\r\n") ;
    Serial.println("Weiter mit \"Enter\"\r\n") ;
    while (!Serial.available())yield();             //Warte bis Seriell etwas reinkommt
    InputEEPR();
    goto sprungmarke;
  }
  // Wlan-Zugang konfigurieren
  WiFi.mode(WIFI_STA);                 //  modus
  WiFi.begin(ssid, passphrase);
  WiFi.printDiag(Serial);              // Wlan Daten seriell ausgeben

  while (WiFi.status() != WL_CONNECTED)// Warten auf verbindung
  {
    delay(500);
    Serial.print(".");
    if (Serial.available()) InputEEPR();    //Ausgand wenn Seriell etwas empfangen
  }                                       // dann Wlan Name und Passwort eingeben

  Serial.println("");                       // Wenn verbunden
  Serial.print("Verbunden mit ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());           // Aktuelle IP des ESP8266-servers zeigen

  //  Bechandlung der Ereignissen anschlissen
  server.on("/", Ereignis_Index);
  server.on("/1.html", Ereignis_SchalteON);
  server.on("/0.html", Ereignis_SchalteOFF);
  server.on("/frame", Ereignis_Frame);

  server.begin();                               // Starte den Server
  Serial.println("HTTP Server gestartet");
}

void InputEEPR()               // Unterprogramm zum eingeben der Wlan-Daten
{
  String Text = "";
  char inser;

  inser = Serial.read();         //
  if (inser == 13)             // Wenn "Enter" bet�tigt, 27 esc
  {
    Serial.println("Input SSID: ");
    for (i = 0; i < 32; i++)     // SSID maximal 32 Byte
    {
      while (!Serial.available()) yield(); //warte bis etwas empfangen wird
      inser = Serial.read();
      Serial.write(inser);                  //Echo

      if (inser == '\r')                    // Wenn zeile abgeschlossen ist
      {
        EEPROM.write(i, '\0');             //Stringende setzen
        break;                            // for schleife verlassen
      } else  EEPROM.write(i, inser);     //nechste Zeichen in EEPROM speichern
    }
    Serial.println("\r\nOK");

    Serial.println("Input Passwort: ");
    for (i = 32; i < 64; i++)              // Passwort maximal 32 Byte
    {
      while (!Serial.available()) yield(); //warte bis etwas empfangen wird
      inser = Serial.read();
      Serial.write(inser);
      if (inser == '\r') // Wenn zeile abgeschlossen ist
      {
        EEPROM.write(i, '\0');  //Stringende setzen
        break;                   // for schleife verlassen
      } else EEPROM.write(i, inser);     //nechste Zeichen empfangen
    }
    EEPROM.commit();                     // EEPROM Schreiben
    Serial.println("\r\nOK");
    Serial.println("Bitte ESP8266 neu starten");
    // esp.reset();
  }
}


void loop()                    //Hautprogramm
{
  if (Serial.available()) InputEEPR();   // Wenn Seriell etwas empfangen
  server.handleClient();                 // Serwerereignisse abarbeiten

  if (!digitalRead(2))                    // Wenn Taster an GPIO2 betaetigt wurde
  {
    val = !val;                              // Schaltzstand �endern
    digitalWrite(0, val);                    // Schaltzstand an denn GPIO2 ausgeben
    while (!digitalRead(2))server.handleClient(); //Warten bis der Taster losgelassen wird
  }
}

